// RomajiBuffer class for KKJConv by N's LAB Copyright (C) 2006 by Nobumichi Kozawa

public class RomajiBuffer
{
    public StringBuffer buff;

    public RomajiBuffer() {
        buff = new StringBuffer();
    }

    public void deleteAll() {
        buff.delete(0, buff.length());
    }

    public int length() {
        return buff.length();
    }

    public void deleteLast(boolean bSmall) {
        int i = buff.length() - 1;
        if (i < 0) return;
        if (buff.charAt(i) == ' ') i--;
        for (; i >= 0; i--) {
            if (buff.charAt(i) == ' ') {
                i++;
                break;
            }
        }
        if (i < 0) i = 0;
        if (!bSmall) buff.delete(i, buff.length());
        else if (buff.charAt(i) == 'l' || buff.charAt(i) == 'x') buff.delete(i, buff.length());
    }

    public String substring(int n, int m) {
        StringBuffer sb = new StringBuffer();
        int j = 0;
        for (int i = 0; i < buff.length(); i++) {
            if (buff.charAt(i) == ' ') {
                j++;
                if (j >= m) break;
            } else if (j >= n) sb.append(buff.charAt(i));
        }
        return sb.toString();
    }

    public String toString() {
        return substring(0, buff.length());
    }

    public void append(String str) {
        buff.append(str);
    }

    public void append(char ch) {
        buff.append(ch);
    }
}